const process = require('process')
const fs = require('fs')
const readline = require('readline')
const path = require('path')

const targets = [
    "Aktuality, Pozvánky",
    "Aktuality, Stalo se, Závody",
    "Aktuality, Stalo se, Závody, HF",
    "Aktuality, Stalo se, Závody, VHF",
    "Aktuality, Stalo se, Akce pro veřejnost",
    "Aktuality, Stalo se, Napsali o nás",
    "Aktuality, Stalo se, Ocenění",
    "Aktuality, Stalo se, Soutěž",
    "Aktuality, Stalo se, SK",
    "Aktuality, Stalo se, Radioklub",
    
    "Články, Programování, C/C++",
    "Články, Programování, Vala",
    "Články, Programování, Javascript",
    "Články, Programování, Nástroje",
    "Články, Programování, LaTeX",
    
    "Články, Mikroprocesory, AVR",
    "Články, Mikroprocesory, Periferie",
    "Články, Mikroprocesory, Knihovny",
    
    "Články, Konstrukce, Konstrukce pro začátečníky",
    "Články, Konstrukce, HAM konstrukce",
    "Články, Konstrukce, Konstrukce s mikroprocesorem",
    
    "Články, Technické články",
    "Články, Technické články, Eagle",
    
    "Články, Zajímavosti",
]

const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout,
    terminal: true,
    completer: function(line) {
        const hits = targets.filter(c => c.indexOf(line) == 0)
        return [ hits, line ]
        //return [ hits.length ? hits : targets, line ]
    },
})

const handleFile = (file) => new Promise((res, rej) => {
    const lines = fs
    .readFileSync(file, 'utf-8')
    .split('\n')

    // print title and current tags
    const tags = lines.filter(l => /^ *tags *=/.exec(l))[0]
    ;(() => {
        const title = lines.filter(l => /^ *title *=/.exec(l))[0]
        
        for(let i = 0; i < 80; i++) console.log()
        console.log(file)
        console.log(tags)
        console.log(title)
    })()
    if(!tags) lines.splice(1,0,"tags = []")

    readline.clearScreenDown(process.stdout)
    rl.question("New tags: ", (tags) => {
        console.log('Got New tags:',tags)
        if(tags.trim() === "") return res()
        let replaced = false
        
        const data = lines.map(l => {
            if(!/^ *tags *=/.exec(l)) return l
            if(replaced) return l
            replaced = true
            return "tags = "+JSON.stringify(tags.split(',').map(a => a.trim()))
        }).join("\n")
        
        fs.writeFileSync(file, data, "utf-8")
        res()
    })
})

const dir = process.argv[2]

let prom = Promise.resolve()
fs.readdirSync(dir)
.forEach(file => {
    prom = prom.then(() => handleFile(path.join(dir, file)))
})

prom
.then(() => rl.close())
.catch(e => {
    console.error(e)
})
